﻿using System;
using System.Linq;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _564592
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("de-AT");
            this.radDateTimePicker1.Format = DateTimePickerFormat.Custom;
            this.radDateTimePicker1.CustomFormat = "dd.MM.yyyy HH:mm";

            RadDateTimePickerCalendar behavior = (this.radDateTimePicker1.DateTimePickerElement.CurrentBehavior as RadDateTimePickerCalendar);
            if (behavior != null)
            {
                behavior.TextBoxElement.Provider = new CustomMaskDateTimeProvider(behavior.TextBoxElement.Provider.Mask, behavior.TextBoxElement.Provider.Culture, behavior.TextBoxElement);
            }
        }
    }

    public class CustomMaskDateTimeProvider : MaskDateTimeProvider
    {
        private RadMaskedEditBoxElement owner;
        private RadTextBoxItem textBoxItem;

        public CustomMaskDateTimeProvider(string mask, System.Globalization.CultureInfo culture, RadMaskedEditBoxElement owner)
            : base(mask, culture, owner)
        {
            this.owner = owner;
            textBoxItem = owner.TextBoxItem;
        }

        protected override bool IsAmPmMode()
        {
            base.IsAmPmMode();

            bool isAMDesignator = !string.IsNullOrEmpty(this.owner.Culture.DateTimeFormat.AMDesignator) && this.textBoxItem.Text.Contains(this.owner.Culture.DateTimeFormat.AMDesignator);
            bool isPMDesignator = !string.IsNullOrEmpty(this.owner.Culture.DateTimeFormat.PMDesignator) && this.textBoxItem.Text.Contains(this.owner.Culture.DateTimeFormat.PMDesignator);
            return isAMDesignator || isPMDesignator;
        }
    }
}
